"""empty message

Revision ID: bd2121c14eaa
Revises: 
Create Date: 2018-09-16 16:10:06.408159

"""
from alembic import op
import sqlalchemy as sa
import portal.database.types


# revision identifiers, used by Alembic.
revision = 'bd2121c14eaa'
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('client',
    sa.Column('id', sa.String(length=36), nullable=False),
    sa.Column('type', sa.Enum('USER', 'WORKER', name='ClientType'), nullable=False),
    sa.Column('codename', sa.String(length=30), nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('codename')
    )
    op.create_table('course',
    sa.Column('created_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('updated_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('name', sa.String(length=50), nullable=False),
    sa.Column('codename', sa.String(length=30), nullable=False),
    sa.Column('description', sa.Text(), nullable=True),
    sa.Column('id', sa.String(length=36), nullable=False),
    sa.Column('notes_access_token', sa.String(length=256), nullable=True),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('codename', name='course_unique_codename')
    )
    op.create_table('group',
    sa.Column('created_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('updated_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('name', sa.String(length=50), nullable=False),
    sa.Column('codename', sa.String(length=30), nullable=False),
    sa.Column('description', sa.Text(), nullable=True),
    sa.Column('id', sa.String(length=36), nullable=False),
    sa.Column('course_id', sa.String(length=36), nullable=False),
    sa.ForeignKeyConstraint(['course_id'], ['course.id'], ondelete='cascade'),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('course_id', 'codename', name='g_course_unique_name')
    )
    op.create_table('project',
    sa.Column('created_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('updated_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('name', sa.String(length=50), nullable=False),
    sa.Column('codename', sa.String(length=30), nullable=False),
    sa.Column('description', sa.Text(), nullable=True),
    sa.Column('id', sa.String(length=36), nullable=False),
    sa.Column('assignment_url', sa.Text(), nullable=True),
    sa.Column('course_id', sa.String(length=36), nullable=False),
    sa.ForeignKeyConstraint(['course_id'], ['course.id'], ondelete='cascade'),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('course_id', 'codename', name='p_course_unique_name')
    )
    op.create_table('role',
    sa.Column('created_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('updated_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('name', sa.String(length=50), nullable=False),
    sa.Column('codename', sa.String(length=30), nullable=False),
    sa.Column('description', sa.Text(), nullable=True),
    sa.Column('id', sa.String(length=36), nullable=False),
    sa.Column('course_id', sa.String(length=36), nullable=False),
    sa.ForeignKeyConstraint(['course_id'], ['course.id'], ondelete='cascade'),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('course_id', 'codename', name='r_course_unique_name')
    )
    op.create_table('secret',
    sa.Column('id', sa.String(length=36), nullable=False),
    sa.Column('name', sa.String(length=40), nullable=False),
    sa.Column('value', sa.String(length=120), nullable=True),
    sa.Column('created_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('expires_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('client_id', sa.String(length=36), nullable=False),
    sa.ForeignKeyConstraint(['client_id'], ['client.id'], ondelete='cascade'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('user',
    sa.Column('created_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('updated_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('id', sa.String(length=36), nullable=False),
    sa.Column('uco', sa.Integer(), nullable=True),
    sa.Column('email', sa.String(length=50), nullable=False),
    sa.Column('name', sa.String(length=50), nullable=True),
    sa.Column('is_admin', sa.Boolean(), nullable=True),
    sa.Column('password_hash', sa.String(length=120), nullable=True),
    sa.ForeignKeyConstraint(['id'], ['client.id'], ),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('email')
    )
    op.create_table('worker',
    sa.Column('created_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('updated_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('id', sa.String(length=36), nullable=False),
    sa.Column('url', sa.String(length=250), nullable=False),
    sa.Column('tags', sa.Text(), nullable=True),
    sa.Column('portal_secret', sa.String(length=64), nullable=True),
    sa.Column('state', sa.Enum('CREATED', 'READY', 'STOPPED', name='WorkerState'), nullable=False),
    sa.ForeignKeyConstraint(['id'], ['client.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('clients_roles',
    sa.Column('client_id', sa.String(length=36), nullable=True),
    sa.Column('role_id', sa.String(length=36), nullable=True),
    sa.ForeignKeyConstraint(['client_id'], ['client.id'], ondelete='cascade'),
    sa.ForeignKeyConstraint(['role_id'], ['role.id'], ondelete='cascade')
    )
    op.create_table('projectConfig',
    sa.Column('created_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('updated_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('id', sa.String(length=36), nullable=False),
    sa.Column('project_id', sa.String(length=36), nullable=False),
    sa.Column('submissions_cancellation_period', sa.Integer(), nullable=True),
    sa.Column('test_files_source', sa.String(length=600), nullable=True),
    sa.Column('test_files_subdir', sa.String(length=50), nullable=True),
    sa.Column('test_files_commit_hash', sa.String(length=64), nullable=True),
    sa.Column('file_whitelist', sa.Text(), nullable=True),
    sa.Column('pre_submit_script', sa.Text(), nullable=True),
    sa.Column('post_submit_script', sa.Text(), nullable=True),
    sa.Column('submission_parameters', sa.Text(), nullable=True),
    sa.Column('submission_scheduler_config', sa.Text(), nullable=True),
    sa.Column('_submissions_allowed_from', sa.TIMESTAMP(timezone=True), nullable=True),
    sa.Column('_submissions_allowed_to', sa.TIMESTAMP(timezone=True), nullable=True),
    sa.Column('_archive_from', sa.TIMESTAMP(timezone=True), nullable=True),
    sa.ForeignKeyConstraint(['project_id'], ['project.id'], ondelete='cascade'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('projects_groups',
    sa.Column('project_id', sa.String(length=36), nullable=True),
    sa.Column('group_id', sa.String(length=36), nullable=True),
    sa.ForeignKeyConstraint(['group_id'], ['group.id'], ondelete='cascade'),
    sa.ForeignKeyConstraint(['project_id'], ['project.id'], ondelete='cascade')
    )
    op.create_table('rolePermissions',
    sa.Column('created_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('updated_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('id', sa.String(length=36), nullable=False),
    sa.Column('role_id', sa.String(length=36), nullable=False),
    sa.Column('view_course_limited', sa.Boolean(), nullable=False),
    sa.Column('view_course_full', sa.Boolean(), nullable=False),
    sa.Column('update_course', sa.Boolean(), nullable=False),
    sa.Column('handle_notes_access_token', sa.Boolean(), nullable=False),
    sa.Column('assign_roles', sa.Boolean(), nullable=False),
    sa.Column('write_roles', sa.Boolean(), nullable=False),
    sa.Column('read_roles', sa.Boolean(), nullable=False),
    sa.Column('write_groups', sa.Boolean(), nullable=False),
    sa.Column('read_groups', sa.Boolean(), nullable=False),
    sa.Column('write_projects', sa.Boolean(), nullable=False),
    sa.Column('read_projects', sa.Boolean(), nullable=False),
    sa.Column('archive_projects', sa.Boolean(), nullable=False),
    sa.Column('create_submissions', sa.Boolean(), nullable=False),
    sa.Column('create_submissions_other', sa.Boolean(), nullable=False),
    sa.Column('resubmit_submissions', sa.Boolean(), nullable=False),
    sa.Column('evaluate_submissions', sa.Boolean(), nullable=False),
    sa.Column('read_submissions_all', sa.Boolean(), nullable=False),
    sa.Column('read_submissions_groups', sa.Boolean(), nullable=False),
    sa.Column('read_submissions_own', sa.Boolean(), nullable=False),
    sa.Column('read_all_submission_files', sa.Boolean(), nullable=False),
    sa.Column('read_reviews_all', sa.Boolean(), nullable=False),
    sa.Column('read_reviews_groups', sa.Boolean(), nullable=False),
    sa.Column('read_reviews_own', sa.Boolean(), nullable=False),
    sa.Column('write_reviews_all', sa.Boolean(), nullable=False),
    sa.Column('write_reviews_group', sa.Boolean(), nullable=False),
    sa.Column('write_reviews_own', sa.Boolean(), nullable=False),
    sa.ForeignKeyConstraint(['role_id'], ['role.id'], ondelete='cascade'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('submission',
                    sa.Column('created_at', sa.TIMESTAMP(), nullable=True),
                    sa.Column('updated_at', sa.TIMESTAMP(), nullable=True),
                    sa.Column('id', sa.String(length=36), nullable=False),
                    sa.Column('scheduled_for', sa.TIMESTAMP(timezone=True), nullable=True),
                    sa.Column('parameters', portal.database.types.JSONEncodedDict(), nullable=True),
                    sa.Column('state', sa.Enum('CREATED', 'READY', 'QUEUED', 'IN_PROGRESS', 'FINISHED', 'CANCELLED', 'ABORTED', 'ARCHIVED', name='SubmissionState'), nullable=False),
                    sa.Column('note', portal.database.types.JSONEncodedDict(), nullable=True),
                    sa.Column('source_hash', sa.String(length=64), nullable=True),
                    sa.Column('user_id', sa.String(length=36), nullable=False),
                    sa.Column('project_id', sa.String(length=36), nullable=False),
                    sa.Column('async_task_id', sa.String(length=36), nullable=True),
                    sa.ForeignKeyConstraint(['project_id'], ['project.id'], ondelete='cascade'),
                    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ondelete='cascade'),
                    sa.PrimaryKeyConstraint('id')
                    )
    op.create_table('users_groups',
    sa.Column('user_id', sa.String(length=36), nullable=True),
    sa.Column('group_id', sa.String(length=36), nullable=True),
    sa.ForeignKeyConstraint(['group_id'], ['group.id'], ondelete='cascade'),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ondelete='cascade')
    )
    op.create_table('review',
    sa.Column('created_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('updated_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('id', sa.String(length=36), nullable=False),
    sa.Column('submission_id', sa.String(length=36), nullable=False),
    sa.ForeignKeyConstraint(['submission_id'], ['submission.id'], ondelete='cascade'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('reviewItem',
    sa.Column('created_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('updated_at', sa.TIMESTAMP(), nullable=True),
    sa.Column('id', sa.String(length=36), nullable=False),
    sa.Column('review_id', sa.String(length=36), nullable=False),
    sa.Column('user_id', sa.String(length=36), nullable=True),
    sa.Column('content', sa.Text(), nullable=True),
    sa.Column('file', sa.String(length=256), nullable=False),
    sa.Column('line', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['review_id'], ['review.id'], ondelete='cascade'),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ondelete='cascade'),
    sa.PrimaryKeyConstraint('id')
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('reviewItem')
    op.drop_table('review')
    op.drop_table('users_groups')
    op.drop_table('submission')
    op.drop_table('rolePermissions')
    op.drop_table('projects_groups')
    op.drop_table('projectConfig')
    op.drop_table('clients_roles')
    op.drop_table('worker')
    op.drop_table('user')
    op.drop_table('secret')
    op.drop_table('role')
    op.drop_table('project')
    op.drop_table('group')
    op.drop_table('course')
    op.drop_table('client')
    # ### end Alembic commands ###
