from flask_restplus import Resource

from portal.service.find import FindService
from portal.service.permissions import PermissionsService
from portal.service.rest import RestService


class CustomResource(Resource):
    @property
    def rest(self) -> RestService:
        if not hasattr(self, '__rest_service'):
            setattr(self, '__rest_service', RestService())
        return getattr(self, '__rest_service')

    @property
    def find(self) -> FindService:
        return self.rest.find

    @property
    def permissions(self) -> PermissionsService:
        return self.rest.permissions

    @property
    def client(self):
        return self.rest.auth.client
