from flask_restplus import Namespace, fields

from portal import logger
from portal.rest.custom_resource import CustomResource

management_namespace = Namespace('management')
log = logger.get_logger(__name__)

status_schema = management_namespace.model('StatusSchema', {
    'status': fields.String()
})


@management_namespace.route('/status')
class StatusReport(CustomResource):
    @management_namespace.marshal_with(status_schema)
    def get(self):
        return dict(status="works")
