from portal.service.auth import AuthService
from portal.service.courses import CourseService
from portal.service.emails import EmailService
from portal.service.find import FindService
from portal.service.groups import GroupService
from portal.service.permissions import PermissionsService
from portal.service.projects import ProjectService
from portal.service.reviews import ReviewService
from portal.service.roles import RoleService
from portal.service.secrets import SecretsService
from portal.service.storage import StorageService
from portal.service.submissions import SubmissionsService
from portal.service.users import UserService
from portal.service.workers import WorkerService


class RestService:
    def __init__(self):
        self._auth = AuthService(self)
        self._find = FindService(self)
        self._email = EmailService(self)

    @property
    def emails(self) -> EmailService:
        return self._email

    @property
    def find(self) -> FindService:
        return self._find

    @property
    def auth(self) -> AuthService:
        return self._auth

    @property
    def users(self) -> UserService:
        return UserService(self)

    @property
    def workers(self) -> WorkerService:
        return WorkerService(self)

    @property
    def courses(self) -> CourseService:
        return CourseService(self)

    @property
    def roles(self) -> RoleService:
        return RoleService(self)

    @property
    def groups(self) -> GroupService:
        return GroupService(self)

    @property
    def projects(self) -> ProjectService:
        return ProjectService(self)

    @property
    def permissions(self) -> PermissionsService:
        return PermissionsService(self)

    @property
    def secrets(self) -> SecretsService:
        return SecretsService(self)

    @property
    def submissions(self) -> SubmissionsService:
        return SubmissionsService(self)

    @property
    def reviews(self) -> ReviewService:
        return ReviewService(self)

    @property
    def storage(self) -> StorageService:
        return StorageService(self)
